#ifndef _SELINUX_GET_SID_LIST_H_
#define _SELINUX_GET_SID_LIST_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ss.h>
#include <linux/flask/flask_types.h>
#include <proc_secure.h>
#include <context.h>
#include <errno.h>

#define _DEFCONTEXT_PATH "/etc/security/default_contexts"
#define CONTEXT_BUF_SIZE 1000
#define MAX_CONFIG_SIDS 100
#define SELINUX_DEFAULTUSER "user_u"

extern int get_default_sid (const char* username, security_id_t from_sid,
                     security_id_t* user_sid);
extern int get_ordered_sid_list (const char *user_name, security_id_t from_sid,
                                 security_id_t *ordered_list, int *length);
extern int query_user_sid (security_id_t *ordered_sid_list, int length,
                            security_id_t *user_sid);
extern int manual_user_enter_sid (char *user, security_id_t *user_sid);

#endif
