#define _LARGEFILE64_SOURCE 
#include <fs_secure.h>
#include <security.h>
#include <errno.h>
#include <flask_util.h>

int stat64_secure(const char *pathname, 
		  struct stat64 *buf, 
		  security_id_t *out_sid)
{
	unsigned long args[3];

	if (is_flask_enabled()) {
		args[0] = (unsigned long)pathname;
		args[1] = (unsigned long)buf;
		args[2] = (unsigned long)out_sid;
		return security(SELINUX_MAGIC, SELINUXCALL_STAT64, args);
	} else {
		/* Compatibility for the modified utilities
		   until they are fixed. */
		*out_sid = SECINITSID_UNLABELED;
		return stat64(pathname, buf);
	}
}
