#include <fs_secure.h>
#include <ss.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char **argv)
{
	security_id_t sid;
	int rc, i;
	unsigned long ino;

	if (argc != 4) {
		fprintf(stderr, "usage:  %s sid/context pathname inode\n", argv[0]);
		exit(1);
	}

	sid = atoi(argv[1]);
	if (!sid) {
		rc = security_context_to_sid(argv[1], strlen(argv[1]) + 1,
					     &sid);
		if (rc) {
			perror(argv[1]);
			exit(1);
		}
	}

	ino = atoi(argv[3]);
	if (ichsid(argv[2], ino, sid) < 0) {
		perror(argv[2]);
		exit(2);
	}

	exit(0);
}
