#include <proc_secure.h>
#include <stdlib.h>

int main(int argc, char **argv, char **envp)
{
	FILE *fp;
	security_id_t sid;
	int rc;

	if (argc < 4) {
		printf("usage:  %s sid/context command mode\n",
		       argv[0]);
		exit(1);
	}

	sid = atoi(argv[1]);
	if (!sid) {
		rc = security_context_to_sid(argv[1], strlen(argv[1]) + 1,
					     &sid);
		if (rc) {
			perror(argv[1]);
			exit(1);
		}
	}

	fp = popen_secure(argv[2], argv[3], sid);
	if (!fp) {
		perror("popen_secure");
		exit(2);
	}

	if (pclose_secure(fp) < 0)
		perror("pclose_secure");

	exit(0);
}
