/* Copyright (C) 2001, 2002 Tresys Technology, LLC
 * see file 'COPYING' for use and warranty information */

/* 
 * Author: mayerf@tresys.com 
 */

/* avl-util.h
 *
 * Generic support functions for AVL trees.
 */


#ifndef _APOLICY_AVL_UTIL_H_
#define _APOLICY_AVL_UTIL_H_

#ifdef USE_SORTING
#include "policy.h" 

#define	LEFT	0
#define RIGHT	1

#define  avl_height(idx, list) ((idx < 0) ? -1 : list[idx].height)

#define avl_max_child(idx, list) ((avl_height(list[idx].left, list) - avl_height(list[idx].right, list)) ? \
		avl_height(list[idx].left, list) : avl_height(list[idx].right, list) )
		

int avl_srl(int head, avl_ptrs_t *ptrs);
int avl_srr(int head, avl_ptrs_t *ptrs);
int avl_drl(int head, avl_ptrs_t *ptrs);
int avl_drr(int head, avl_ptrs_t *ptrs);
int avl_get_idx(const char *key, int head, int (*comp)(const char *, int, policy_t *), 
		int (*get_subtree)(int, int, policy_t *), policy_t *policy);
int grow_avl_array(avl_ptrs_t **avl, int sz);



#endif /* USE_SORTING */
#endif /* _APOLICY_AVL_UTIL_H_ */







