/* Copyright (C) 2002 Tresys Technology, LLC
 * see file 'COPYING' for use and warranty information */

/*
 * Author: mayerf@tresys.com
 */

/* policy-avl.h
 *
 * AVL binary tree functions that are aware of the policy database structure.
 */

#ifndef _APOLICY_POLICY_ALV_H_
#define _APOLICY_POLICY_ALV_H_

#ifdef USE_SORTING

#include "policy.h"

int init_avl_trees(policy_t *policy);
int free_avl_trees(policy_t *policy);
int avl_insert_attrib(const int head, char *attrib, int *newidx, policy_t *policy);
int avl_insert_type(const int head, char *type, int *newidx, policy_t *policy);
int type_compare(const char *key, int idx, policy_t *policy);
int attrib_compare(const char *key, int idx, policy_t *policy);
int get_type_subtree(int idx, int dir, policy_t *policy);
int get_attrib_subtree(int idx, int dir, policy_t *policy);
int avl_insert_class(const int head, char *classname, int *newidx, policy_t *policy);
int avl_insert_perm(const int head, char *perm, int *newidx, policy_t *policy);
int class_compare(const char *key, int idx, policy_t *policy);
int perm_compare(const char *key, int idx, policy_t *policy);
int get_class_subtree(int idx, int dir, policy_t *policy);
int get_perm_subtree(int idx, int dir, policy_t *policy);

#endif /* USE_SORTING */
#endif /*_APOLICY_POLICY_ALV_H_ */

