 /* Copyright (C) 2001-2003, Tresys Technology, LLC
 * see file 'COPYING' for use and warranty information */

/* 
 * Author: mayerf@tresys.com 
 */

/* apolicy */

/* Utility functions */

#ifndef _APOLICY_UTIL_H_
#define _APOLICY_UTIL_H_

#include <stdlib.h>
#include "policy.h"

#define VERSION_STRING "0.7.1"

/* generic link list structures */
typedef struct llist_node {
	void 			*data;	/* data of any type or structure */
	struct llist_node	*prev;
	struct llist_node	*next;
} llist_node_t;

typedef struct llist {
	int		num;
	llist_node_t	*head;
	llist_node_t	*tail;
} llist_t;


/* NOTE: rules_bool_t (used for TE rules)  and 
 * rbac_bool_t (used for RBAC rules) are defined in policy.h 
 */
bool_t getbool(const char *str);
void fix_string(char *str, int sz);
llist_t *ll_new(void);
void ll_free(llist_t *ll, void(*free_data)(void *));
llist_node_t *ll_node_free(llist_node_t *n, void(*free_data)(void *));
int ll_unlink_node(llist_t *ll, llist_node_t *n);
int ll_insert_data(llist_t *ll, llist_node_t *n, void *data);
int ll_append_data(llist_t *ll, void *data) ;
int init_rules_bool(bool_t include_audit, rules_bool_t *rules_b, policy_t *policy);
int init_rbac_bool(rbac_bool_t *b, policy_t *policy);
int all_true_rules_bool(rules_bool_t *rules_b, policy_t *policy);
int all_false_rules_bool(rules_bool_t *rules_b, policy_t *policy);
int all_true_rbac_bool(rbac_bool_t *b, policy_t *policy);
int free_rules_bool(rules_bool_t *rules_b);
int free_rbac_bool(rbac_bool_t *b);
char* uppercase(const char *instr, char *outstr) ;
int add_i_to_a(int i, int *cnt, int **a);
int find_int_in_array(int i, const int *a, int a_sz);
int add_int_to_array(int i, int *a, int num, int a_sz);
bool_t is_name_in_list(const char *name, ta_item_t *list,policy_t *policy);


#endif /*_APOLICY_UTIL_H_*/




